// EncPciBasicTestDlg.cpp : implementation file
//

#include "stdafx.h"
#include "EncPciBasicTest.h"
#include "EncPciBasicTestDlg.h"
#include "EncPciFunctions.h"
#include "EncPciConst.h"

#define MAX_PCI_CARDS 10
// (MAX_PCI_CARDS is rather arbitrary. The array below has
// MAX_PCI elements, indexed 0 through MAX_PCI_CARDS-1.)
long CardHandleArray[MAX_PCI_CARDS-1] ;
short CardsDetected ;

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CAboutDlg dialog used for App About

class CAboutDlg : public CDialog
{
public:
	CAboutDlg();

// Dialog Data
	//{{AFX_DATA(CAboutDlg)
	enum { IDD = IDD_ABOUTBOX };
	//}}AFX_DATA

	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CAboutDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:
	//{{AFX_MSG(CAboutDlg)
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

CAboutDlg::CAboutDlg() : CDialog(CAboutDlg::IDD)
{
	//{{AFX_DATA_INIT(CAboutDlg)
	//}}AFX_DATA_INIT
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CAboutDlg)
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)
	//{{AFX_MSG_MAP(CAboutDlg)
		// No message handlers
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CEncPciBasicTestDlg dialog

CEncPciBasicTestDlg::CEncPciBasicTestDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CEncPciBasicTestDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CEncPciBasicTestDlg)
		// NOTE: the ClassWizard will add member initialization here
	//}}AFX_DATA_INIT
	// Note that LoadIcon does not require a subsequent DestroyIcon in Win32
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CEncPciBasicTestDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CEncPciBasicTestDlg)
		// NOTE: the ClassWizard will add DDX and DDV calls here
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CEncPciBasicTestDlg, CDialog)
	//{{AFX_MSG_MAP(CEncPciBasicTestDlg)
	ON_WM_SYSCOMMAND()
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_BN_CLICKED(IDC_FLASH, OnFlash)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CEncPciBasicTestDlg message handlers

BOOL CEncPciBasicTestDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Add "About..." menu item to system menu.

	// IDM_ABOUTBOX must be in the system command range.
	ASSERT((IDM_ABOUTBOX & 0xFFF0) == IDM_ABOUTBOX);
	ASSERT(IDM_ABOUTBOX < 0xF000);

	CMenu* pSysMenu = GetSystemMenu(FALSE);
	if (pSysMenu != NULL)
	{
		CString strAboutMenu;
		strAboutMenu.LoadString(IDS_ABOUTBOX);
		if (!strAboutMenu.IsEmpty())
		{
			pSysMenu->AppendMenu(MF_SEPARATOR);
			pSysMenu->AppendMenu(MF_STRING, IDM_ABOUTBOX, strAboutMenu);
		}
	}

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon
	
	// TODO: Add extra initialization here
                char msg [200] ;
                long CardHandle ;
		short CardIndex ;
		short OK ;  // 0 = Success, 1 = Failure.
		SetActive(1);        // Locate all the existing EIC-325/PCI cards:
		for (CardIndex = 0 ; (CardIndex < MAX_PCI_CARDS) ; CardIndex++) {
			OK = GetCardHandle (&CardHandle, CardIndex) ;
			if (OK == 0) break ;  // No more cards.

            // (EIC-325/PCI card detected.)

            // Store the result in an array:
            CardHandleArray[CardIndex] = CardHandle ;
		}

        // Report how many cards were detected:
        // Note that current CardIndex = how many cards were detected.
        CardsDetected = CardIndex ;
        switch (CardsDetected) 
        {
            case 0:
				MessageBox("No 'EIC-325/PCI' cards detected!", NULL, MB_ICONSTOP) ;
				exit(0) ;
                break ;
            case 1:
				MessageBox("One 'EIC-325/PCI' card detected.") ;
				break ;
            default:
                sprintf (msg, "%d 'EIC-325/PCI' cards were detected. The 'Flash' will apply sequentially to all recognized cards.", CardsDetected) ;
				MessageBox(msg) ;
                break ;
        }
	
	return TRUE;  // return TRUE  unless you set the focus to a control
}

void CEncPciBasicTestDlg::OnSysCommand(UINT nID, LPARAM lParam)
{
	if ((nID & 0xFFF0) == IDM_ABOUTBOX)
	{
		CAboutDlg dlgAbout;
		dlgAbout.DoModal();
	}
	else
	{
		CDialog::OnSysCommand(nID, lParam);
	}
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void CEncPciBasicTestDlg::OnPaint() 
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc(), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

// The system calls this to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR CEncPciBasicTestDlg::OnQueryDragIcon()
{
	return (HCURSOR) m_hIcon;
}

void CEncPciBasicTestDlg::OnFlash() 
{
	// TODO: Add your control notification handler code here
	
	// Flash the LEDs of all detected card(s):
        for (short CardIndex = 0 ; CardIndex < CardsDetected ; CardIndex++) {
        	long CardHandle = CardHandleArray[CardIndex] ;
        	for (int i=1 ; i<=10 ; i++ ) {
        		SetLed(CardHandle,LedYellow,TurnOff);
        		SetLed(CardHandle,LedRed,TurnOn);
        		Sleep(100);
        		SetLed(CardHandle,LedYellow,TurnOn);
        		SetLed(CardHandle,LedRed,TurnOff);
        		Sleep(100);
        	}
        }
}

void CEncPciBasicTestDlg::OnOK() 
{
	// TODO: Add extra validation here
	
	SetActive(0);
	CDialog::OnOK();
}
